package com.ruoyi.system.user.service;

import java.util.Collections;
import java.util.List;

import com.ruoyi.common.core.domain.vo.UserVO;

/**
 * @author wjh
 * 2024/11/22
 */
public interface UserValidator {

    /**
     * 校验用户
     * @param vo
     */
    void validate(UserVO vo);

    /**
     * 当前用户是否可以查看用户
     * @param userId
     * @return
     */
    default boolean canView(Long userId) {
        return canView(Collections.singletonList(userId));
    }

    /**
     * 当前用户是否可以查看用户
     * @param userIds
     * @return
     */
    boolean canView(List<Long> userIds);

    /**
     * 校验用户账号是否唯一
     * @param user
     * @return
     */
    boolean checkUserNameUnique(UserVO user);

    /**
     * 当前用户是否可以操作用户
     * @param adminId
     * @return
     */
    boolean canEdit(Long userId);

}
